#include "funzioni.hpp"

using namespace cv ;
using namespace std;

int main()
{
    //Loading of distributions
    double distribution_SW_P[51], distribution_SW_N[51]={};
    double data_SWV_P[POSITIVE_SAMPLES]={};
    double data_SWV_N[NEGATIVE_SAMPLES]={};
    caricaDistribuzione("./distribution/CueSWVimP.txt",data_SWV_P);
    caricaDistribuzione("./distribution/CueSWVimN.txt",data_SWV_N);
    histc(data_SWV_P, POSITIVE_SAMPLES, 0.04, distribution_SW_P);
    histc(data_SWV_N, NEGATIVE_SAMPLES, 0.04, distribution_SW_N);

    double distribution_HOG_P[51], distribution_HOG_N[51]={};
    double data_HOG_P[POSITIVE_SAMPLES]={};
    double data_HOG_N[NEGATIVE_SAMPLES]={};
    caricaDistribuzione("./distribution/CueHOGimP.txt",data_HOG_P);
    caricaDistribuzione("./distribution/CueHOGimN.txt",data_HOG_N);
    histc(data_HOG_P, POSITIVE_SAMPLES, 0.02, distribution_HOG_P);
    histc(data_HOG_N, NEGATIVE_SAMPLES, 0.02, distribution_HOG_N);

    double distribution_PD_P[51], distribution_PD_N[51]={};
    double data_PD_P [POSITIVE_SAMPLES]={};
    double data_PD_N [NEGATIVE_SAMPLES]={};
    caricaDistribuzione("./distribution/CuePDimP.txt",data_PD_P);
    caricaDistribuzione("./distribution/CuePDimN.txt",data_PD_N);
    histc(data_PD_P, POSITIVE_SAMPLES, 0.7, distribution_PD_P);
    histc(data_PD_N, NEGATIVE_SAMPLES, 0.7, distribution_PD_N);

    // Use this to load all the database
    //    for(int immagine = 100; immagine < 329; immagine ++)
    //    {
    //        stringstream percorso;
    //        percorso << "./icdar/" << immagine << ".jpg";
    //        //cout << percorso.str() << endl;

    //        Mat source = imread(percorso.str(), CV_LOAD_IMAGE_COLOR);


    Mat source = imread("150.jpg", CV_LOAD_IMAGE_COLOR);

    // Check for invalid input
    if(!source.data )
    {
        cout <<  "Could not open or find the image" << endl ;
        return -1;
    }
    cout << "Image is open \n\n" ;
    //    namedWindow("source",WINDOW_NORMAL);
    //    imshow("source",source);

    Mat brightGrayImg(source.rows, source.cols,CV_8U);
    Mat darkGrayImg(source.rows,source.cols, CV_8U);

    PreEMSER(source , &brightGrayImg, &darkGrayImg, false);
    //    imshow("brightGrayImg", brightGrayImg);
    //    imshow("darkGrayImg", darkGrayImg);

    //Definition of regions which will contain in each position a vector containing itself the set of
    //points that belong to that region
    vector<vector<Point> > regions_b;
    vector<vector<Point> > regions_d;

    Mat bright_MSER = bright_MSER.zeros(brightGrayImg.size(), brightGrayImg.type());
    vl_feat_mser (brightGrayImg, regions_b,&bright_MSER ,MSER_BRIGHT_ON_DARK);

    Mat dark_MSER = dark_MSER.zeros(darkGrayImg.size(), darkGrayImg.type());
    vl_feat_mser (darkGrayImg, regions_d, &dark_MSER ,MSER_DARK_ON_BRIGHT);

    //    imshow("bright MSER", bright_MSER);
    //    imshow("dark MSER", dark_MSER);

    //Stroke width method
    vector<double> CueSW_d, CueSW_b;
    CueSW_b = ComputeStrokeWidth(bright_MSER, regions_b);
    CueSW_d = ComputeStrokeWidth(dark_MSER, regions_d);
    cout << "Calcolo Stroke width terminato" << endl; //"Le regioni sono: "<<CueSW_b.size() << " e "<< CueSW_d.size() << endl;

    //Perceptual divergence method
    vector<double> CuePD_b, CuePD_d;
    CuePD_b = ComputePD(source, regions_b);
    CuePD_d = ComputePD(source, regions_d);
    cout << "Calcolo PD terminato" << endl;

    //eHOG method
    vector<double> EHOG_d(regions_d.size());
    vector<double> EHOG_b(regions_b.size());
    EHOG_d = ComputeEHOG(source, regions_d );
    EHOG_b = ComputeEHOG(source, regions_b );
    cout << "Calcolo eHOG  terminato" << endl;

    //Checking for elements that must be deleted
    regions_b = deleting_elements(CueSW_b, CuePD_b, EHOG_b, regions_b);
    regions_d = deleting_elements(CueSW_d, CuePD_d, EHOG_d, regions_d);

    //Normalization of result to be comparable with histograms
    vector<int> risehog_b(EHOG_b.size());
    vector<int> risehog_d(EHOG_d.size());
    vector<int> rissw_b(CueSW_b.size());
    vector<int> rissw_d(CueSW_d.size());
    vector<int> rispd_b(CueSW_b.size());
    vector<int> rispd_d(CueSW_d.size());

    //Application of algorithm to obtain the result for each method (both for bright and dark)
    int numero = 0;
    risehog_b = regions_cue(EHOG_b, distribution_HOG_P, distribution_HOG_N, source, regions_b,numero);
    numero++;
    risehog_d = regions_cue(EHOG_d,distribution_HOG_P,distribution_HOG_N,source,regions_d,numero);
    numero++;
    rissw_b = regions_cue(CueSW_b,distribution_SW_P,distribution_SW_N,source,regions_b,numero);
    numero++;
    rissw_d = regions_cue(CueSW_d,distribution_SW_P,distribution_SW_N,source,regions_d,numero);
    numero++;
    rispd_b = regions_cue(CuePD_b,distribution_PD_P,distribution_PD_N,source,regions_b,numero);
    numero++;
    rispd_d = regions_cue(CuePD_d,distribution_PD_P,distribution_PD_N,source,regions_d,numero);

    //Application of Bayes
    Mat bayes_b(source.size(),CV_8U);
    bayes_b=Bayes(distribution_SW_P, distribution_SW_N, distribution_PD_P, distribution_PD_N, distribution_HOG_P, distribution_HOG_N, CueSW_b, CuePD_b, EHOG_b, source, regions_b);

    Mat bayes_d(source.size(),CV_8U);
    bayes_d=Bayes(distribution_SW_P, distribution_SW_N, distribution_PD_P, distribution_PD_N, distribution_HOG_P, distribution_HOG_N, CueSW_d, CuePD_d, EHOG_d, source, regions_d);

    //Saving the Bayes's results
    stringstream ss,ss1;
    //    ss << "./testing/" << immagine << "_b.png";
    //    ss1 << "./testing/" << immagine << "_d.png";
    ss << "./prova_b.png";
    ss1 << "./prova_d.png";

    imwrite(ss.str(),bayes_b);
    imwrite(ss1.str(),bayes_d);

    //}
    waitKey();
    //}
    return 0;
}
